#!/usr/local/bin/ruby -Ke

#require 'kconv'
#require 'uconv'

dn = 'mixi_diary'
ofn = 'for_hatena.xml'

File.open(ofn, 'w'){|ofh|
	ofh.print '<?xml version="1.0" encoding="EUC-JP"?>',"\r"
	ofh.print "<diary>","\r"

	last_day = nil
	Dir.foreach(dn){|ifn|
		next if ifn !~ /^([0-9]+).html$/
		
		# htmlɤ߼
		body = ''
		File.open("#{dn}/#{ifn}"){|fh| body = fh.read }
		
		# html
		body.sub! /([0-9]+)ǯ([0-9]+)([0-9]+)\<[Bb][Rr]\>([0-9]+):([0-9]+)\<\/td\>[\r\n]*\<td[^\>]*\>\&nbsp\;(.*)\<\/td\>\<\/tr\>/, ''
		all, yyyy, mm, dd, hh, ss, title = Regexp.last_match.to_a

		body.sub! /h12\>(.*)\<\/td\>/, ''
		all, value = Regexp.last_match.to_a
		
		unless value
			print "convert failed: #{ifn}\n"
			next
		end
		
		#title = Uconv::euctou8(title)
		#value = Uconv::euctou8(value)
		
		# 
		value.gsub! /\<[bB][rR]\>/, '<br />'
		value.gsub! /\<a href\=[^\>]*\>([^\<]*)\<\/a\>/, '\\1'
		#value.split(/[\r\n]*\<[bB][rR]\>/)
		
		if last_day != [yyyy, mm, dd]
			ofh.print "</body>\r</day>\r" if last_day != nil
			last_day = [yyyy, mm, dd]
			ofh.print "<day date=\"#{yyyy}-#{mm}-#{dd}\" title=\"#{title}\">","\r"
			ofh.print "<body>","\r"
		end
		ofh.print "*#{title}","\r"
		ofh.print "#{value}","\r"
		#diary.push [ all, yyyy, mm, dd, hh, ss, title, value ]
	}
	ofh.print "</body>\r</day>\r" if last_day != nil
	ofh.print "</diary>","\r"
}
